/* $Id$ */
/*
 * Copyright (c) 2003 Jose Nazario <jose@monkey.org>.  
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <stdio.h>
#include "stree.h"

char *stringlist;
char *buf;

LST_StringSet *
new_set(void) {
	return(lst_stringset_new());
}

void 
add_string(LST_StringSet *set, char *string) {
	LST_String    *lst_string = NULL;
	lst_string = lst_string_new(string, 1, strlen(string));
	lst_stringset_add(set, lst_string);
}

LST_STree *
make_tree(LST_StringSet *set) {
	return(lst_stree_new(set));
}

void
destroy_tree(LST_STree *tree) {
	lst_stree_free(tree);
}

/*
 interface to longest_common_substring().
 hand it the same args as longest_common_substring().
 */

LST_StringSet *
longest_common_substring(LST_STree *tree, int min, int max) {
	return(lst_alg_longest_common_substring(tree, min, max));
}

/*
 interface to lst_alg_longest_repeated_substring().
 hand it the same args as lst_alg_longest_repeated_substring().
 */

LST_StringSet *
longest_repeated_substring(LST_STree *tree, int min, int max) {
	return(lst_alg_longest_repeated_substring(tree, min, max));
}
