/* $Id$ */
/*
 * Copyright (c) 2003 Jose Nazario <jose@monkey.org>.  
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

%module stree

%{
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

#include "stree.h"
%}

LST_STree      *make_tree (LST_StringSet *set);
LST_StringSet  *new_set (void);
void 		add_string (LST_StringSet *set, char *string);
LST_StringSet  *longest_common_substring (LST_STree *tree, int min, int max);
LST_StringSet  *longest_repeated_substring (LST_STree *tree, int min, int max);
// int		get_strings (LST_StringSet *set);
void 		destroy_tree (LST_STree *tree);

%inline %{
void
build_string_list(LST_String *string, void *data) {
	sprintf(data, "%s", (char *)lst_string_print(string));
}

char *
get_strings(LST_StringSet *tree) {
	char *buf;

	if ((buf = malloc(4096)) == NULL) 
		return(NULL);
	lst_stringset_foreach(tree, (LST_StringCB)build_string_list, buf);
	return(buf);
}
%}
