#!/usr/local/bin/tcl8.3/
# $Id$

load ./stree.so

set stree_set [stree::new_set]
stree::add_string $stree_set "foo to you and me"
stree::add_string $stree_set "foo to me and you"
stree::add_string $stree_set "foo to all the people in the deep blue sea"
set my_stree [stree::make_tree $stree_set]
set s [stree::longest_repeated_substring $my_stree 0 0]
puts [stree::get_strings $s]

stree::destroy_tree $my_stree

set stree_set [stree::new_set]
stree::add_string $stree_set "this is a very long string"
stree::add_string $stree_set "this is a very looong string"
set my_stree [stree::make_tree $stree_set]
set s [stree::longest_repeated_substring $my_stree 0 0]
puts [stree::get_strings $s]
set s [stree::longest_common_substring $my_stree 1 5]
puts [stree::get_strings $s]
set my_stree [stree::make_tree $stree_set]
set s [stree::longest_common_substring $my_stree 1 5]
puts [stree::get_strings $s]
puts "strings were [stree::get_strings $stree_set]"
stree::destroy_tree $my_stree

set stree_set [stree::new_set]
set f [open "/tmp/words" r]
set r [read $f]
foreach word [split $r "\n"] {
	stree::add_string $stree_set $word
}
set my_stree [stree::make_tree $stree_set]
set s [stree::longest_repeated_substring $my_stree 0 0]
puts [stree::get_strings $s]
set s [stree::longest_common_substring $my_stree 0 0]
puts [stree::get_strings $s]
stree::destroy_tree $my_stree
